﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Globalization;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;
using Infragistics.Windows;

namespace xamDataGridComboEditor
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<Person> data { get; set; }
        public ObservableCollection<Person> data1 { get; set; }

        public MainWindow()
        {
            InitializeComponent();
            data = new ObservableCollection<Person>();

            data.Add(new Person() { Id = 1, LastName = "tedy", Age = 34.444 });
            data.Add(new Person() { Id = 2, LastName = "ani", Age = 34.5555 });
            data.Add(new Person() { Id = 3, LastName = "Doe", Age = 56 });
            data.Add(new Person() { Id = 4, LastName = "Smith", Age = 23 });


            data1 = new ObservableCollection<Person>();
            data1.Add(new Person() { Id = 1, LastName = "tedy", Age = 34.444 });
            data1.Add(new Person() { Id = 2, LastName = "Doe", Age = 34.5555 });
            data1.Add(new Person() { Id = 3, LastName = "Doe", Age = 56 });
            data1.Add(new Person() { Id = 4, LastName = "Smith", Age = 23 });
            xamDataGrid1.DataSource =  data1;
        }

        void EndEvent(object sender, Infragistics.Windows.Editors.Events.EditModeEndingEventArgs e)
        {
            (sender as XamComboEditor).Value = ((sender as XamComboEditor).SelectedItem as Person).LastName;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            (data[0] as Person).LastName  = "KURRR" ;
            
            foreach (var item in xamDataGrid1.Records)
            {
                CellValuePresenter.FromRecordAndField(item as DataRecord, item.FieldLayout.Fields[0]).Editor.StartEditMode();
                CellValuePresenter.FromRecordAndField(item as DataRecord, item.FieldLayout.Fields[0]).EndEditMode(true, false);
            }
        }
    }

    public class Person : INotifyPropertyChanged
    {
        private int id;


        public int Id
        {
            get { return id; }
            set
            {
                id = value;
                NotifyPropertyChanged("Id");
            }
        }

        private double age;

        public double Age
        {
            get { return age; }
            set { age = value; NotifyPropertyChanged("Age"); }
        }

        private String lastName;

        public String LastName
        {
            get { return lastName; }
            set { lastName = value; NotifyPropertyChanged("LastName"); }
        }


        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    }
    
}
